#include "datbackup.h"
#include "nums/numdata.h"

extern void stopreceiver() ;
constexpr const char orsettings[]="orsettings.dat";

extern std::vector<Numdata*> numdatas;
/*
void 	updateone::setbackupstarttime(const uint32_t starttime) {
	if(sendstream||sendscans) 
		sensors->setbackuptime(ind,starttime,sendstream,sendscans);
	for(int i=0;i<numdatas.size();i++)
		numdatas[i]->setbackupstarttime(nums,starttime);
	}
	*/
 void uptodate(int ind) {
 	LOGGER("uptodate %d\n",ind);
	lastuptodate[ind]=time(nullptr);
	}

void uptodate(passhost_t *host) {
	if(backup)
		uptodate(host-backup->getupdatedata()->allhosts);
	}
int updateone::update() {
	crypt_t *pass=getcrypt();
	bool sendsensors=(sendstream||sendscans) ;
	int ret =0;
	if(starttime) {
		if(starttime==1)  {
			if(sendnums) {
				for(auto el:numdatas)
					if(! el->sendbackupinit(pass,getsock(),nums) )
						return 0;
				}
			}
		else {
			if(sendnums) {
				bool numsbackupsendinit(crypt_t*pass,int sock,struct changednums *nuall,uint32_t starttime) ;
				if(!numsbackupsendinit(pass,getsock(),nums, starttime) )
					return 0;
			}

			if(sendsensors) {
				if( !sensors->setbackuptime(pass, getsock(),ind,starttime)) 
					return 0;
				}
			}
		starttime=0;
		ret=1;
	   }

	int subdid=updatenums();
	if(!subdid)
		return 0;
	ret|=subdid;
	if(sendsensors) {
		subdid=sensors->update(pass,getsock(),ind,startsensors,firstsensor,sendstream,sendscans,restore);
		if(!subdid)
			return 0; 
		ret|=subdid;
		}
	auto update= settings->getupdate();
	static bool init=true;
	if(update>updatesettings||init) {
		init=false;
		std::vector<subdata> vect;
		vect.reserve(2+(restore?1:0));
		if(sendnums) {
			bool nochangenum =true;
			vect.push_back({reinterpret_cast<const senddata_t *>(&nochangenum),offsetof(Tings,nochangenum),sizeof(nochangenum)});
			}
		constexpr const int  sharedstart=offsetof(Tings, update);
		constexpr const int len=offsetof(Tings, reserved4)-sharedstart;
		vect.push_back({reinterpret_cast<const senddata_t *>( settings->data())+sharedstart,sharedstart,len});
		if(restore) {
			Readall<senddata_t> orset(pathconcat(globalbasedir,orsettings));
			vect.push_back({orset.data(),0,orset.length()});
			if(!senddata(pass,getsock(),vect,settingsdat) ) 
				return 0;
			}
		else {
			if(!senddata(pass,getsock(),vect,settingsdat) ) 
				return 0;
			if(!senddata(pass,getsock(),0, reinterpret_cast<const senddata_t *>( settings->data()),	sharedstart,orsettings))
				return 0;
			}
		ret=1;
		}
	updatesettings=update;

	if(restore) {
		Readall<senddata_t> back(pathconcat(globalbasedir,orbackup));
		if(back) {
			if(!senddata(pass,getsock(),0, back.data(),back.size(),backupdat))
				return 0;
			}
		ret=1;
		}
	else
	if(!backupupdated) {
		if(!senddata(pass,getsock(),0, backup->mapdata.data(),	backup->mapdata.size()*sizeof(backup->mapdata.data()[0]),orbackup))
			return 0;
		backupupdated=1;
		ret=1;
		}

  	uptodate(allindex) ;
	noacksendone(pass,getsock(), suptodate);
	return ret;
//	return sendrender(getsock());

	}
int 	updateone::updatenums() {
	if(!sendnums)
		return 2;
	int soc=getsock();
	if(soc<0)
		return 0;
	return ::updatenums(getcrypt(),soc,nums);
	}

int  updateone::updatestream() {
	if(!sendstream)
		return 2;
	return sensors->updatestream(getcrypt(),getsock(),ind,firstsensor);
 	} 
int updateone::updatescans() {
	if(!sendscans)
		return 2;
	return sensors->updatescans(getcrypt(),getsock(),ind,firstsensor);
 	} 
bool netwakeup(int sock,passhost_t *pass,crypt_t *ctx){
	if(backup) {
		LOGGER("netwakeup %d\n",sock);
#ifdef REVERSECONNECT
		int sin=pass->index;
		if(sin>=0) {
		       updateone &host=backup->getupdatedata()->tosend[sin];
		       if(host.getsock()<0) {
				LOGGER("use sock\n");
				if(ctx) {
					crypt_t *crypt=host.getcrypt();
					if(!crypt)
						return false;
					memcpy(crypt,ctx,sizeof(crypt_t));;
					}
				host.setsock(sock);
//				backup->wakebackuponly(Backup::wakeall);
				backup->wakebackup(Backup::wakeall);
				return true;
				}
			else
				LOGGER("old sock=%d\n",host.getsock());
			}
#endif
		//backup->wakebackuponly(Backup::wakeall|Backup::wakereconnect);
		backup->wakebackup(Backup::wakeall|Backup::wakereconnect);
		}
	return false;
	}
bool networkpresent=false;


int hostsocks[maxallhosts];
uint32_t lastuptodate[maxallhosts]={};
//int *sendsocks=nullptr;
//crypt_t **crypts=nullptr;
std::vector<int> sendsocks;
//std::vector<std::vector<int>> tmpsocks;
//int tmpsocks[maxallhosts][maxip];
std::vector<crypt_t *> crypts;
Backup *backup=nullptr;
void	updateone::open() {
	     LOGGER("updateone::open");
		auto *host=backup->getupdatedata()->allhosts+allindex;
		if(!host->sendpassive)
			opensender(host,getsock(),getcrypt());
		}


//extern int opensender(passhost_t *pass,int &sock,crypt_t*ctx) ;

bool turnreceiver(int sock,passhost_t *hostptr,crypt_t *ctxptr) ;
						
void sendup(passhost_t *hostptr) {
	const bool haspas= hostptr->haspass();
	LOGGER("wake sender %spass\n",(haspas?"":"no" ));
	crypt_t ctx;
	crypt_t *ctxptr=haspas?&ctx:nullptr;

        prctl(PR_SET_NAME, "wake sender", 0, 0, 0);
	if(int sock;opensender(hostptr,sock,ctxptr)>=0) {
		if(sendbackup(ctxptr,sock)) {

#ifdef REVERSECONNECT
			LOGGER("sendup %d: success %d\n",agettid(),sock);	
//			int ind=hostptr-backup->getupdatedata()->allhosts;
			if(hostsocks[ind]==-1) {
				hostsocks[ind]=sock;
				LOGGER("turnreceiver\n");
				if(turnreceiver(sock,hostptr,ctxptr))
					return;
				}
			else {
				LOGGER("sendup hostsocks[ind]=%d\n",hostsocks[ind]);
				}
#endif
			}
		else
			LOGGER("%d: failure %d\n",agettid(),sock);	

		close(sock);
		}
	}

extern std::vector<Backup::condvar_t*> active_receive;
std::vector<Backup::condvar_t*> active_receive;
#include <chrono>
using namespace std::chrono_literals;
void activereceivethread(int allindex,passhost_t *pass) {
	constexpr const int maxbuf=50;
	char buf[maxbuf];
	int h=pass->activereceive-1;
#ifndef NDEBUG
	int slen=
#endif
		snprintf(buf,maxbuf, "%d activereceivethread",h);
	LOGGERN(buf,slen);
       prctl(PR_SET_NAME, buf, 0, 0, 0);
	const bool haspas= pass->haspass();
	crypt_t ctx,*ctxptr=haspas?&ctx:nullptr;
	decltype(active_receive[h]->dobackup) current{};
	decltype(std::chrono::system_clock::now()) tim;
	while(true) {
		  active_receive[h]->dobackup=active_receive[h]->dobackup&(~current);
			{
		    std::unique_lock<std::mutex> lck(active_receive[h]->backupmutex);
	//		active_receive[h]->backupcond.wait(lck, [h] {return active_receive[h]->dobackup; });   
			active_receive[h]->backupcond.wait_until(lck,tim+60s);   
			current=active_receive[h]->dobackup;
			}
		 tim = std::chrono::system_clock::now();
		if(current&Backup::wakeend) {
			close(hostsocks[allindex]);
			hostsocks[allindex]=-1;
		       delete active_receive[h];
			active_receive[h]=nullptr;
			LOGGER("end activereceivethread");
			return;
			}

		int &sock=hostsocks[allindex];
		if(opensender(pass,sock,ctxptr)<0)
			continue;
		if(current&Backup::wakesend) {
			sendup(pass);
			}
bool	activegetcommands(int sock,passhost_t *host,crypt_t *ctx) ;
		LOGGER("before activegetcommands\n");
		activegetcommands(sock,pass,ctxptr); 
		LOGGER("after activegetcommands\n");
		close(sock);
		sock=-1;
		if(ctxptr) 
			ascon_aead_cleanup(ctxptr);

		}
	}
void updatedata::wakesender() {
	for(int i=0;i<hostnr;i++) {
		passhost_t &host=allhosts[i];
		if(host.activereceive) {
			active_receive[host.activereceive-1]->wakebackup(Backup::wakeall);
			}
		else {
			if(host.receivefrom==3&&host.index<0) {
				std::thread wake(sendup,&host);
				wake.detach();
				}
			else {
				if(host.index>=0&&backup->con_vars[host.index])
					  backup->con_vars[host.index]->wakebackup(Backup::wakesend);
					  
				}
			}
		}
	}

void passivesender(int sock,passhost_t *pass)  {
	LOGGER("passivesender %d\n",sock);
	 if(!networkpresent) {
		close(sock);
		return;
		}
	int h=pass->index;
	updateone &host=backup->getupdatedata()->tosend[h];
	if(h>=0&&backup->con_vars[h]) {
		int oldsock=host.getsock();
		if(oldsock>=0) {
			host.setsock(-1);
			::shutdown(oldsock,SHUT_RDWR);
			close(oldsock);
			}
		const bool haspas= pass->haspass();
		if(haspas) {
			bool	receivepassinit(int ,passhost_t *,crypt_t *);
			if(!receivepassinit(sock,pass,host.getcrypt()))  {
				close(sock);
				return ;
				}
			}
		host.setsock(sock); 
		LOGGER("wakebackup\n");
		 backup->con_vars[h]->wakebackup(Backup::wakeall);
		 }
	}

/*
	int h=pass->index;
	updateone &host=backup->getupdatedata()->tosend[h];
	host.close();
	host.setsock(sock); */
	


bool getpassive(int pos) {
	if(pos<backup->getupdatedata()->hostnr)  {
		const auto &host=backup->getupdatedata()->allhosts[pos];
		if(host.index>=0)
			return host.sendpassive;
		return host.receivefrom==2;
		}
	return false;
	}
bool getactive(int pos) {
	if(pos<backup->getupdatedata()->hostnr)  {
		const auto &host=backup->getupdatedata()->allhosts[pos];
		if(host.index>=0) {
			if(host.sendpassive) 
				return false;
			return !host.receivefrom;
			}
			
		return host.activereceive;
		}
	return false;
	}
